<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="indexpage" kind="group">
    <compoundname>index</compoundname>
    <title>CapSense Middleware Library</title>
    <detaileddescription>
<para>TBD: Overall documentation update will be done later.CapSense is a Cypress capacitive sensing solution. Capacitive sensing can be used in a variety of applications and products where conventional mechanical buttons can be replaced with sleek human interfaces to transform the way users interact with electronic systems. These include home appliances, and automotive, IoT, and industrial applications. CapSense supports multiple interfaces (widgets) using both CSX and CSD sensing methods with robust performance.</para><para>CapSense has become a popular technology to replace conventional mechanical- and optical-based user interfaces. There are fewer parts involved, which saves cost and increases reliability with no wear-and-tear. The main advantages of CapSense compared with other solutions are: robust performance in harsh environmental conditions and rejection of a wide range of external noise sources.</para><para>Use CapSense for:<itemizedlist>
<listitem><para>Touch and gesture detection for various interfaces</para></listitem><listitem><para>Proximity detection for innovative user experiences and low-power optimization</para></listitem><listitem><para>Contactless liquid-level sensing in a variety of applications</para></listitem><listitem><para>Touch-free operations in hazardous materials</para></listitem></itemizedlist>
</para>
<para><heading level="1">General Description</heading></para>
<para>The CSD HW block enables multiple sensing capabilities on PSoC devices including self-cap and mutual-cap capacitive touch sensing solution, a 10-bit ADC, IDAC, and Comparator. The CSD driver is a low-level peripheral driver, a wrapper to manage access to the CSD HW block. Each middleware access to the CSD HW block is through the CSD Driver.</para><para>The CSD HW block can support only one function at a time. However, all supported functionality (like CapSense, ADC, etc.) can be time-multiplexed in a design. I.e. you can save the existing state of the CapSense middleware, restore the state of the ADC middleware, perform ADC measurements, and then switch back to the CapSense functionality. For more details and code examples refer to the description of the <ref kindref="member" refid="group__group__capsense__high__level_1ga899ef1058ead082503771da68e584b82">Cy_CapSense_Save()</ref> and <ref kindref="member" refid="group__group__capsense__high__level_1gaf87102783ec511c2e5f2024680112d16">Cy_CapSense_Restore()</ref> functions.</para><para><image name="capsense_solution.png" type="html" width="800px">CapSense Solution</image>
 
</para><para>This section describes only CapSense middleware. Refer to the corresponding sections for documentation of other middleware supported by the CSD HW block.</para><para>A CapSense solution includes:<itemizedlist>
<listitem><para>The CapSense Configurator tool, which is a configuration wizard to create and configure CapSense widgets. It could be launched in ModusToolbox from the CSD personality as well as in standalone mode. It contains a separate document about how to create and configure widgets, parameters and algorithm descriptions.</para></listitem><listitem><para>API to control the design from the application program. This documentation describes API with code snippets of how to use them.</para></listitem><listitem><para>The CapSense Tuner tool for real-time tuning, testing, and debugging, for easy and smooth designing of human interfaces on customer products. The Tuner tool communicates with a device through a HW bridge and communication drivers (EzI2C, UART, etc.) and allows to monitor widget statuses, sensor signals, detected touch positions, gestures, etc. The application program does not need to interact with the CSD driver and/or other drivers such as GPIO, SysClk directly. All of that is configured and managed by middleware.</para></listitem></itemizedlist>
</para><para>Include cy_capsense.h to get access to all functions and other declarations in this library. If you are using the ModusToolbox CapSense Configurator tool, you can include cycfg_capsense.h only.</para>
<para><bold>Features</bold></para>
<para><itemizedlist>
<listitem><para>Offers best-in-class signal-to-noise ratio (SNR)</para></listitem><listitem><para>Supports Self-Capacitance (CSD) and Mutual-Capacitance (CSX) sensing methods</para></listitem><listitem><para>Features SmartSense auto-tuning technology for CSD sensing to avoid complex manual tuning process</para></listitem><listitem><para>Supports various Widgets, such as Buttons, Matrix Buttons, Sliders, Touchpads, and Proximity Sensors</para></listitem><listitem><para>Provides ultra-low power consumption and liquid-tolerant capacitive sensing technology</para></listitem><listitem><para>Contains the integrated graphical CapSense Tuner tool for real-time tuning, testing, and debugging</para></listitem><listitem><para>Provides superior immunity against external noise and low-radiated emission</para></listitem><listitem><para>Offers best-in-class liquid tolerance</para></listitem><listitem><para>Supports one-finger and two-finger gestures</para></listitem></itemizedlist>
</para>


<para><heading level="1">Quick Start Guide</heading></para>
<para>CapSense middleware can be used in various Development Environments such as ModusToolbox, MBED, etc. Refer to the <ref kindref="member" refid="index_1section_capsense_toolchain">Supported Software and Tools</ref>. The quickest way to get started is using the Code Examples. Cypress Semiconductor continuously extends its portfolio of the code examples at the <ulink url="http://www.cypress.com">Cypress Semiconductor website</ulink> and at the <ulink url="https://github.com/cypresssemiconductorco">Cypress Semiconductor GitHub</ulink>.</para><para>This quick start guide assumes that the environment is configured to use the PSoC 6 Peripheral Driver Library(psoc6pdl) for development and the PSoC 6 Peripheral Driver Library(psoc6pdl) is included in the project. It also assumes the <ulink url="https://www.cypress.com/ModusToolboxDeviceConfig">ModusToolbox Device Configurator Tool</ulink>, <ulink url="https://www.cypress.com/ModusToolboxCapSenseConfig">ModusToolbox CapSense Configurator Tool</ulink>, and <ulink url="https://www.cypress.com/ModusToolboxCapSenseTuner">ModusToolbox CapSense Tuner Tool</ulink> are installed on your machine.</para>
<para><bold>MBED OS Quick Start Guide</bold></para>
<para>You can immediately start with the following MBED OS code example available at the <ulink url="https://github.com/cypresssemiconductorco"> Cypress Semiconductor GitHub</ulink>:<itemizedlist>
<listitem><para><ulink url="https://github.com/cypresssemiconductorco/mbed-os-example-capsense">CapSense buttons and slider for PSoC 6 MCU with Mbed OS</ulink></para></listitem></itemizedlist>
</para><para>If you are doing your own project, remember to include cycfg.h file: <programlisting><codeline><highlight class="preprocessor">#include<sp />"cycfg.h"</highlight><highlight class="normal" /></codeline>
</programlisting> and call the resource initialization functions in main() at the beginning: <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp />init_cycfg_all();</highlight></codeline>
</programlisting></para>


<para><heading level="1">Summary of Application Programming Interface (API)</heading></para>
<para>The CapSense operates on the top of the CapSense Sigma Delta (CSD) driver. Refer to the PDL API Reference Manual.</para><para>This document provides descriptions of the functions in the CapSense middleware library, and descriptions of the data structures (register map) used by the middleware library.</para><para>The Application Programming Interface (API) routines allow controlling and executing specific tasks using the CapSense middleware. The CapSense API is described in the following sections:<itemizedlist>
<listitem><para><ref kindref="compound" refid="group__group__capsense__high__level">High-level Functions</ref></para></listitem><listitem><para><ref kindref="compound" refid="group__group__capsense__low__level">Low-level Functions</ref></para></listitem><listitem><para><ref kindref="compound" refid="group__group__capsense__data__structure">CapSense Data Structure</ref></para></listitem><listitem><para><ref kindref="compound" refid="group__group__capsense__enums">Enumerated Types</ref></para></listitem><listitem><para><ref kindref="compound" refid="group__group__capsense__macros">Macros</ref></para></listitem><listitem><para><ref kindref="compound" refid="group__group__capsense__callbacks">Callbacks</ref></para></listitem></itemizedlist>
</para>

<para><heading level="1">Supported Software and Tools</heading></para>
<para>TBD: Supported tool version will be specified later.</para><para>This version of the CapSense Middleware was validated for compatibility with the following Software and Tools: <verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Software and Tools &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Version  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;ModusToolbox Software Environment &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;2.1  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;- ModusToolbox Device Configurator &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;2.1  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;- ModusToolbox CSD Personality for PSoC4 devices in Device Configurator &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1.0  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;- ModusToolbox CSD Personality for PSoC6 devices in Device Configurator &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;2.0  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;- ModusToolbox CapSense Configurator tool &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;3.0  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;- ModusToolbox CapSense Tuner tool &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;3.0  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;PSoC4 Peripheral Driver Library (PDL) &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1.0.0  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;PSoC6 Peripheral Driver Library (PDL) &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1.5.0  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;GCC Compiler &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;7.2.1  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;IAR Compiler &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;8.32  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Arm Compiler 6 &lt;superscript&gt;&lt;b&gt;(Note 1)&lt;/b&gt;&lt;/superscript&gt; &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;6.11  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;MBED OS (only for PSoC6) &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;5.15.1  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;FreeRTOS &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;10.0.1  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para><para><bold>Note 1</bold> The CapSense middleware includes the pre-compiled libraries for Arm Compiler 6. They are built with the following options to be compatible with ModusToolbox and MBED:</para><para><itemizedlist>
<listitem><para>-fshort-enums – Set the size of an enumeration type to the smallest data type that can hold all enumerator values</para></listitem><listitem><para>-fshort-wchar - Set the size of wchar_t to 2 bytes</para></listitem></itemizedlist>
</para><para>To operate in custom environments with Arm Compiler 6, apply the above mentioned build options.</para>

<para><heading level="1">Update to Newer Versions</heading></para>
<para>Refer to the <ref kindref="member" refid="index_1section_capsense_changelog">Changelog</ref> to learn about the design impact of the newer version. Set up your environment in accordance with <ref kindref="member" refid="index_1section_capsense_toolchain">Supported Software and Tools</ref>.</para><para>Ensure:<itemizedlist>
<listitem><para>The specified version of the ModusToolbox Device Configurator and the CSD personality are used to re-generate the device configuration.</para></listitem><listitem><para>The specified version of the ModusToolbox CapSense Configurator is used to re-generate the middleware configuration.</para></listitem><listitem><para>The toolchains are set up properly for your environment per the settings outlined in the Supported Software and Tools.</para></listitem><listitem><para>The project is re-built once the toolchains are configured and the configuration is completed.</para></listitem></itemizedlist>
</para><para>You might need to re-generate the configuration structures for either the device initialization code or the middleware initialization code.<itemizedlist>
<listitem><para>Launch the ModusToolbox Device Configurator and perform the File-&gt;Save command to re-generate the device initialization code.</para></listitem><listitem><para>From the ModusToolbox Device Configurator, launch the ModusToolbox CapSense Configurator and perform the File-&gt;Save command to re-generate the middleware initialization code.</para></listitem></itemizedlist>
</para>

<para><heading level="1">Memory Usage</heading></para>
<para>The CapSense middleware Flash and RAM memory consumption varies:<itemizedlist>
<listitem><para>marginally - depending on the compiler and device</para></listitem><listitem><para>significantly - depending on the project CapSense configuration and number of APIs called by the application program.</para></listitem></itemizedlist>
</para><para>The table below provides the middleware total memory consumption for specific CapSense configurations. Memory consumption for any custom design/configuration can be determined by analyzing a *.map file generated by the compiler.</para><para>The measurements were done with GCC compiler configured in the Release mode with optimization set for Size.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Configuration:&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Configuration 1&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Configuration 2&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Configuration 3&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Configuration 4&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Configuration 5&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Configuration 6&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Configuration 7 &lt;b&gt; &lt;/b&gt;&lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;&lt;b&gt;Flash:&lt;/b&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;&lt;b&gt;&amp;lt; 13600&lt;/b&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;&lt;b&gt;&amp;lt; 15750&lt;/b&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;&lt;b&gt;&amp;lt; 18700&lt;/b&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;&lt;b&gt;&amp;lt; 20300&lt;/b&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;&lt;b&gt;&amp;lt; 28400&lt;/b&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;&lt;b&gt;&amp;lt; 19900&lt;/b&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;&lt;b&gt;&amp;lt; 34700 &lt;/b&gt;&lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;&lt;b&gt;SRAM:&lt;/b&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;&lt;b&gt;&amp;lt; 400&lt;/b&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;&lt;b&gt;&amp;lt; 730&lt;/b&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;&lt;b&gt;&amp;lt; 2200&lt;/b&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;&lt;b&gt;&amp;lt; 1080&lt;/b&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;&lt;b&gt;&amp;lt; 4280&lt;/b&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;&lt;b&gt;&amp;lt; 600&lt;/b&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;&lt;b&gt;&amp;lt; 4480 &lt;/b&gt; &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td class="head" colspan="8"&gt;&lt;p&gt;Widgets &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CSD Button&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1 (6 sensors)&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1 (6 sensors)&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1 (2 sensors)&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1 (6 sensors)&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1 (6 sensors)&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1 (6 sensors) &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CSD Matrix Buttons&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CSD Slider&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1 (9 segments)&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1 (9 segments)&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1 (9 segments) &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CSD Touchpad&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1 (9 Cols and 8 Rows)&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1 (9 Cols and 8 Rows)&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1 (9 Cols and 8 Rows) &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CSD Proximity&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1 (1 sensor)&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1 (1 sensor)&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1 (1 sensor)&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1 (1 sensor) &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CSX Button&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CSX Matrix Buttons&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1 (3 Rx and 3 Tx)&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1 (3 Rx and 3 Tx) &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CSX Touchpad&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1 (9 Rx and 8 Tx)&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1 (9 Rx and 8 Tx)&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1 (9 Rx and 8 Tx) &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td class="head" colspan="8"&gt;&lt;p&gt;Features &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Gesture&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Ballistic Multiplier&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Centroid Type&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;3x3&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;3x3&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;5x5 CSD, 3x3 CSX&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;5x5 CSD, 3x3 CSX &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Supported fingers on touchpad&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;2&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;2&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;2 &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Shield&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;SmartSense&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CSD auto-calibration&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CSX auto-calibration&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Self-test&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td class="head" colspan="8"&gt;&lt;p&gt;Raw Count Filters &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;IIR&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Median&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Average&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td class="head" colspan="8"&gt;&lt;p&gt;Position Filters &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;IIR&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Median&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Average&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Adaptive IIR&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Jitter&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;enabled &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">MISRA-C Compliance</heading></para>
<para>TBD: Report violation using Coverity+MISRA2012 will be provided later.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;MISRA Rule &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Class (Required/Advisory) &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Description &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Description of Deviation(s)  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;11.4 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A conversion should not be performed between a pointer to object and an integer type. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Such conversion is performed with CapSense context in two cases: interrupt handler and DeepSleepCallback function. Both cases are verified on correct operation.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;12.13 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The increment (++) and decrement (-) operators should not be mixed with other operators in an expression. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;These violations are reported for the GCC ARM optimized form of the "for" loop that have the following syntax: for(index = COUNT; index &lt;ndash /&gt;&amp;gt; 0u;) It is used to improve performance.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.2 &lt;/p&gt;&lt;/td&gt;&lt;td rowspan="2"&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td rowspan="2"&gt;&lt;p&gt;Constant: Dereference of NULL pointer. &lt;/p&gt;&lt;/td&gt;&lt;td rowspan="2"&gt;&lt;p&gt;These violations are reported as a result of using of offset macros of CSD Driver with corresponding documented violation 20.6. Refer to CSD Driver API Ref Guide.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;20.3  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">Errata</heading></para>
<para>TBD: Errata section will be updated later.</para><para>This section lists the known problems with the CapSense middleware.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;ID&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Known Issue&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Workaround &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;319100 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;GPIO simultaneous operation with unrestricted strength and frequency creates noise that can affect CapSense operation.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Refer to the errata section of the device datasheet for details.&lt;br /&gt; &lt;a href="http://www.cypress.com/ds218787"&gt;PSoC 63 with BLE Datasheet Programmable System-on-Chip&lt;/a&gt;   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;3159 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Scanning a sensor with low capacitance (about 8pF and less) with low frequency (around 300kHz and less) might lead to raw count variation from scan to scan.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;There are several possible workarounds:&lt;ol&gt;&lt;li&gt;&lt;p&gt;Increase the Scan resolution.&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Increase the Sense clock frequency. For the best results, perform scanning with as high as possible Sense clock frequency.&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;If shield is required for a design, enable the shield tank (Csh) capacitor.&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Increase the sensor capacitance by changing its layout or introduce extra capacitor between the sensor pin and ground.&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Increase number of Fine initialization cycles. Open the cycfg_capsense.c file and modify the .csdFineInitTime field of the cy_capsense_commonConfig structure.&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Increase the CSD init switch resistance. Open the cycfg_capsernse.c file and update the .csdInitSwRes field of the cy_capsense_commonConfig structure with the CY_CAPSENSE_INIT_SW_RES_HIGH value.   &lt;/p&gt;&lt;/li&gt;&lt;/ol&gt;&lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;3191 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Channel 0 is scanned with the incorrect settings when all of the following conditions are met:&lt;ol&gt;&lt;li&gt;&lt;p&gt;Multi-frequency scan is enabled.&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;The &lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1ga898ff1a676637f32c34140f88d5d275f"&gt;Cy_CapSense_CSDSetupWidgetExt()&lt;/a&gt; function called only once.&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;The &lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1ga93d8ff09f519f7bfd17b5bf4bcb8f727"&gt;Cy_CapSense_CSDScanExt()&lt;/a&gt; function called multiple times.  &lt;/p&gt;&lt;/li&gt;&lt;/ol&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Call the &lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1ga898ff1a676637f32c34140f88d5d275f"&gt;Cy_CapSense_CSDSetupWidgetExt()&lt;/a&gt; function before each call of the &lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1ga93d8ff09f519f7bfd17b5bf4bcb8f727"&gt;Cy_CapSense_CSDScanExt()&lt;/a&gt; function.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">Changelog</heading></para>
<para>TBD: All changes in 3.0 will be provided later.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Version&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Changes&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Reason for Change &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="2"&gt;&lt;p&gt;3.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Removed usage of deprecated return error and status codes, cy_status enum was replaced with the cy_capsense_status_t variable &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Defect fixing  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Removed usage of deprecated types, such as uint32 and uint16 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Defect fixing  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="9"&gt;&lt;p&gt;2.10 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added Built-in Self-test (BIST) library &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Support Class B (IEC-60730), safety integrity-level compliant design  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Improved the Csh and Cmod coarse initialization functionality. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Feature enhancement  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Improved the shield performance when Csh is enabled &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Feature enhancement  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Fixed &lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1ga31834a3fce1f5b57c72107b419626bab"&gt;Cy_CapSense_ScanExt()&lt;/a&gt; operation &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Defect fixing  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Fixed the bug in the &lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1gaf51fd91df09631045f83396237395777"&gt;Cy_CapSense_SetPinState()&lt;/a&gt; function &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Defect fixing  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Optimized software watch-dog values used in monitoring CapSense scanning duration &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;User experience improvement  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Improved IDAC auto-calibration &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Operation accuracy increasing  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added the following functions:&lt;ul&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1gad7e65a2d7d0a17cf276d6276538ccf63"&gt;Cy_CapSense_GetParam()&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1ga780c1508cc90d688be3b73d6b2771510"&gt;Cy_CapSense_SetParam()&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1ga2de812825cd421ee05fec733206e157a"&gt;Cy_CapSense_GetCRC()&lt;/a&gt;  &lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Feature enhancement  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Changed the type of context argument to const in the following functions:&lt;ul&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1ga5b0e78b06f8929fab12d4d68d655b7e6"&gt;Cy_CapSense_CSDConnectSns()&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1gaaef5abe61c0b9f59a004f9ce91a75aba"&gt;Cy_CapSense_CSXConnectRx()&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1ga6cc6ab21c0b3604c197e5f8b545a6c2b"&gt;Cy_CapSense_CSXConnectTx()&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1ga4f21c0d5c554bd80ad2aed31795d913e"&gt;Cy_CapSense_CSXDisconnectRx()&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1ga9238cba162d3c0622e804a89aad9db55"&gt;Cy_CapSense_CSXDisconnectTx()&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1gaf51fd91df09631045f83396237395777"&gt;Cy_CapSense_SetPinState()&lt;/a&gt;  &lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Defect fixing  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="6"&gt;&lt;p&gt;2.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added memory usage section to the CapSense API Ref Guide &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;User experience improvement  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated documentation &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;User experience improvement  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added the errata section to the CapSense API Ref Guide &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;User experience improvement  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CapSense MW sources are enclosed with the conditional compilation to ensure a successful compilation for non-CapSense-capable devices &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Fixing a compilation error for non CapSense-capable devices  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Optimized flash memory consumption based on user's configuration &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Flash foot-print optimization  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Renamed function Cy_CapSense_CheckCommandIntegrity() to &lt;a href="group__group__capsense__high__level.html#group__group__capsense__high__level_1ga1f0fdedcec1ad936f5e9e4ae28f17274"&gt;Cy_CapSense_CheckTunerCmdIntegrity()&lt;/a&gt; &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;User experience improvement  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="2"&gt;&lt;p&gt;1.20 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added Arm Compiler 6 support &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Feature enhancement  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Changed the hierarchy of the binary files folders &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;MBED OS compatibility  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="6"&gt;&lt;p&gt;1.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The following functions made obsolete:&lt;ul&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1gaff00959c95147f8374b1629caa45c43c"&gt;Cy_CapSense_CSDSetupWidget()&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1ga898ff1a676637f32c34140f88d5d275f"&gt;Cy_CapSense_CSDSetupWidgetExt()&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1gad5faac7e10eb8c4193d7c93b5615ac70"&gt;Cy_CapSense_CSDScan()&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1ga93d8ff09f519f7bfd17b5bf4bcb8f727"&gt;Cy_CapSense_CSDScanExt()&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1ga2b550696b7b308b7234b9c1ff048e300"&gt;Cy_CapSense_CSDCalibrateWidget()&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1ga4a13b66055d7d1649c47cb75d1d65f62"&gt;Cy_CapSense_CSXSetupWidget()&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1ga39248233bf04b09b3e24d02b6e615d32"&gt;Cy_CapSense_CSXSetupWidgetExt()&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1gaa76f71d361d42796da2a716a207766cd"&gt;Cy_CapSense_CSXScan()&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1gaeba90684124922020af9fa5ad33d54fc"&gt;Cy_CapSense_CSXScanExt()&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1ga4b37af6aea35e86eaac9667583d31f9e"&gt;Cy_CapSense_CSXCalibrateWidget()&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/p&gt;&lt;p&gt;Two simple functions introduced to replace the listed above functions:&lt;ul&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1gaf43c0cf61a95f11a5981f82f5b0d4e86"&gt;Cy_CapSense_SetupWidgetExt()&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__capsense__low__level.html#group__group__capsense__low__level_1ga31834a3fce1f5b57c72107b419626bab"&gt;Cy_CapSense_ScanExt()&lt;/a&gt;  &lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;User experience improvement  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Fixed the shield operation when Csh is disabled &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Defect fixing  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Fixed the implementation of the position filtering for the Radial Slider widget &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Defect fixing  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added restoring hardware to its default state in the &lt;a href="group__group__capsense__high__level.html#group__group__capsense__high__level_1ga7b8a365213dde3be6c6932dc23fdcee6"&gt;Cy_CapSense_DeInit()&lt;/a&gt; implementation &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Defect fixing  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added the capability to enable the shield electrode without dedicated electrodes &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Feature enhancement  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added support of a protocol-agnostic tuner interface (UART, SPI, etc.) &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Feature enhancement  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The initial version  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">More Information</heading></para>
<para>Important information about the CapSense-technology overview, appropriate Cypress device for the design, CapSense system and sensor design guidelines, different interfaces and tuning guidelines necessary for a successful design of a CapSense system is available in the Getting Started with CapSense document and the product-specific CapSense design guide. Cypress highly recommends starting with these documents. They can be found on the Cypress web site at www.cypress.com.</para><para>For more information, refer to the following documents:</para><para><itemizedlist>
<listitem><para><ulink url="https://www.cypress.com/products/modustoolbox-software-environment">ModusToolbox Software Environment, Quick Start Guide, Documentation, and Videos</ulink></para></listitem><listitem><para><ulink url="https://github.com/cypresssemiconductorco"> Cypress Semiconductor GitHub</ulink></para></listitem><listitem><para><ulink url="https://github.com/cypresssemiconductorco/mbed-os-example-capsense">CapSense buttons and slider for PSoC 6 MCU with Mbed OS</ulink></para></listitem><listitem><para><ulink url="https://www.cypress.com/documentation/code-examples/ce218136-psoc-6-mcu-e-ink-display-capsense-rtos">CapSense Middleware Code Example for FreeRTOS</ulink></para></listitem><listitem><para><ulink url="https://www.cypress.com/ModusToolboxCapSenseConfig">ModusToolbox CapSense Configurator Tool Guide</ulink></para></listitem><listitem><para><ulink url="https://www.cypress.com/ModusToolboxCapSenseTuner">ModusToolbox CapSense Tuner Tool Guide</ulink></para></listitem><listitem><para><ulink url="https://www.cypress.com/ModusToolboxDeviceConfig">ModusToolbox Device Configurator Tool Guide</ulink></para></listitem><listitem><para><ulink url="https://www.cypress.com/documentation/application-notes/an85951-psoc-4-and-psoc-6-mcu-capsense-design-guide">CapSense Design Guide</ulink></para></listitem><listitem><para><ulink url="https://cypresssemiconductorco.github.io/csdadc/csdadc_api_reference_manual/html/index.html">CSDADC Middleware API Reference Guide</ulink></para></listitem><listitem><para><ulink url="https://cypresssemiconductorco.github.io/csdidac/csdidac_api_reference_manual/html/index.html">CSDIDAC Middleware API Reference Guide</ulink></para></listitem><listitem><para><ulink url="https://cypresssemiconductorco.github.io/psoc6pdl/pdl_api_reference_manual/html/index.html">PDL API Reference</ulink></para></listitem><listitem><para><ulink url="http://www.cypress.com/an210781">AN210781 Getting Started with PSoC 6 MCU with Bluetooth Low Energy (BLE) Connectivity</ulink></para></listitem><listitem><para><ulink url="https://www.cypress.com/documentation/technical-reference-manuals/psoc-6-mcu-psoc-63-ble-architecture-technical-reference">PSoC 6 Technical Reference Manual</ulink></para></listitem><listitem><para><ulink url="http://www.cypress.com/ds218787">PSoC 63 with BLE Datasheet Programmable System-on-Chip datasheet</ulink></para></listitem><listitem><para><ulink url="http://www.cypress.com">Cypress Semiconductor</ulink></para></listitem></itemizedlist>
</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The links to another software component’s documentation (middleware and PDL) point to GitHub to the latest available version of the software. To get documentation of the specified version, download from GitHub and unzip the component archive. The documentation is available in the &lt;i&gt;docs&lt;/i&gt; folder. &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>